var preloader = function() {	
	return {
		
		imgLoadList:[],
		imgLoadCnt:0,
		version:"0.09",
		
		initialize: function(){
			preloader.consoleLog( "[EDGE][PRELOADER] version : " + preloader.version );
		},
		
		consoleLog: function( obj ) {
			console.log( obj );
		},
		
		consoleWarn: function( obj ) {
			console.warn( obj );
		},
		
		addPreloadImage: function( imageID , src ) {
			console.log( imageID + " : " + src );
			var image = new Image;
			preloader.imgLoadList.push( { imageID:imageID , src:src , image:image } );
		},
		
		delegateCreate : function ( __target, __func )
		{
			var f = function()
			{
				return arguments.callee._func.apply(arguments.callee._target, arguments.callee._args);
			};
			 
			f._target = __target;
			f._func = __func;
			
			var _args = [];
			if( arguments.length > 2 ){
				for ( var i = 2; i < arguments.length; i++ ) {
					_args.push( arguments[i] );
				}
			}
			f._args = _args;
			 
			return f;
		},
		
		__allLoad: function() {
			
			preloader.consoleLog( "[PRELOADER] allLoad ___________________" );
			
			if( preloader.imgLoadList.length == 0 ){
				preloader.consoleLog( "[PRELOADER]   -> PRELOAD LIST NOTHING -> onAllLoaded" );
				preloader.onAllLoaded();
			} else {
				preloader.consoleLog( "[PRELOADER]   -> loadstart length : " + preloader.imgLoadList.length );
				for( var i = 0; i<preloader.imgLoadList.length; i++ ){
					var info = preloader.imgLoadList[ i ];
					var image = info.image;
					image.onload = preloader.delegateCreate( preloader , preloader.imgLoaded , i , info );
					image.onerror = preloader.delegateCreate( preloader , preloader.imgLoadError , i , info );
					image.src = info.src;
				}
				// 
			}
		},
		
		imgLoadError: function( loaderID , info ) {
			preloader.consoleWarn( "[PRELOADER] imgLoadError ___________________" );
			preloader.consoleWarn( "imageID : " + info.imageID );
			preloader.consoleWarn( "src : " + info.src );
		},
		
		imgLoaded: function( loaderID , info ) {
			preloader.consoleLog( "[PRELOADER] imgLoaded ___________________" );
			preloader.consoleLog( "imageID : " + info.imageID );
			preloader.consoleLog( "src : " + info.src );
			
			preloader.imgLoadCnt++;
			
			if( preloader.imgLoadList.length == preloader.imgLoadCnt ){
				preloader.onAllLoaded();
			}
		},
		
		// 読み込み完了 // 外部より指定
		onAllLoaded: function() {},
		
		// ロード開始
		startAllLoad: function( scope , symbol , callback ) {
			preloader.consoleLog( "[PRELOADER] checkToStart ___________________" );
			preloader.consoleLog( "[PRELOADER] version : " + preloader.version );
			// preloader.consoleLog( "[PRELOADER] checkViewMode __flashvars.__swiffy : " + __flashvars.__swiffy );
			
			// callback
			preloader.onAllLoaded = preloader.delegateCreate( scope , callback , symbol , 1 , 2 , 3 );
			
			preloader.__allLoad();
		}
	}
}();